/**
 *  Copyright © 2025, Luis Andrés Lange <https://javacomm.net>
 *
 *  Previously released under Apache License 2.0; now licensed under MPL 2.0.
 *
 *  This Source Code Form is subject to the terms of the Mozilla Public
 *  License, v. 2.0. If a copy of the MPL was not distributed with this
 *  file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 *  ----------------------------------------------------------------------------
 *
 *  Exhibit B - "Incompatible With Secondary Licenses" Notice
 *
 *  This Source Code Form is "Incompatible With Secondary Licenses",
 *  as defined by the Mozilla Public License, v. 2.0.
 *
 *  In short:
 *  - This file may be used, modified, and distributed under MPL 2.0 only.
 *  - It may NOT be relicensed under GPL, LGPL, AGPL, or any other Secondary License.
 *
 *  Rationale:
 *  - Ensures that the code remains MPL-2.0.
 *  - Avoids legal conflicts with GPL-licensed libraries (e.g., VideoLAN).
 *  - Maximizes usability for commercial and security-critical applications.
 *
 */
package net.javacomm.protocol;

import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import java.lang.reflect.Type;



public class CallPrivateChatSerializer implements JsonSerializer<CALLPRIVATECHAT> {

  public CallPrivateChatSerializer() {}



  @Override
  public JsonElement serialize(CALLPRIVATECHAT callPrivateChat, Type type, JsonSerializationContext context) {

    JsonObject jsonObject = new JsonObject();
    JsonObject dataset = new JsonObject();

    dataset.add(CALLPRIVATECHAT.SENDER_UID, context.serialize(callPrivateChat.getSenderUID()));
    dataset.add(CALLPRIVATECHAT.RECIPIENT_UID, context.serialize(callPrivateChat.getRecipientUID()));
    dataset.add(CALLPRIVATECHAT.LOCAL_NICKNAME, context.serialize(callPrivateChat.getLocalNickname()));
    dataset.add(CALLPRIVATECHAT.REMOTE_NICKNAME, context.serialize(callPrivateChat.getRemoteNickname()));
    dataset.add(CALLPRIVATECHAT.LOCAL_SESSIONID, context.serialize(callPrivateChat.getLocalSessionid()));
    dataset.add(CALLPRIVATECHAT.REMOTE_SESSIONID, context.serialize(callPrivateChat.getRemoteSessionid()));
    dataset.add(CALLPRIVATECHAT.ERRORMESSAGE, context.serialize(callPrivateChat.getErrorMessage()));
    dataset.add(CALLPRIVATECHAT.TEXT, context.serialize(callPrivateChat.getText()));
    if (
      callPrivateChat.getMultilingualkey() != null
    ) dataset.add(
        CALLPRIVATECHAT.MULTILINGUALKEY, context.serialize(callPrivateChat.getMultilingualkey().value())
    );

    jsonObject.add("HEADER", context.serialize(callPrivateChat.getHeader()));
    jsonObject.add("COMMAND", context.serialize(callPrivateChat.getCommand()));
    jsonObject.add("DATASET", context.serialize(dataset));

    return jsonObject;
  }

}
